{$reference System.Drawing.dll}
uses TData,System.Drawing;

var
  f := char(9608);
  e := ' ';

procedure AddLeter(b: Bitmap; X, Y: integer; ch: char);
begin
  var BitMap := new byte[8, 12];
  for dx: byte := 0 to 7 do
    for dy: byte := 0 to 11 do
      BitMap[dx, dy] := b.GetPixel(X + dx, Y + dy).R = 0 ? 0 : 1;
  Leters.Add(ch, BitMap);
end;

procedure SaveLaters;
begin
  var wr := new System.IO.BinaryWriter(System.IO.File.Create('TData.dll'));
  foreach var ch in Leters.Keys do
  begin
    wr.Write(new byte[2](word(ch) shr 8, word(ch)));
    var b := Leters[ch];
    for y: byte := 0 to 11 do
      wr.Write(byte(
      (b[0, y] = 1 ? $01 : 0) +
      (b[1, y] = 1 ? $02 : 0) +
      (b[2, y] = 1 ? $04 : 0) +
      (b[3, y] = 1 ? $08 : 0) +
      (b[4, y] = 1 ? $10 : 0) +
      (b[5, y] = 1 ? $20 : 0) +
      (b[6, y] = 1 ? $40 : 0) +
      (b[7, y] = 1 ? $80 : 0)
      ));
  end;
  wr.BaseStream.Close;
end;

procedure ShowChar(ch:char);
begin
    if not Leters.ContainsKey(ch) then
    begin
      System.Console.Clear;
      writeln('!');
      exit;
    end;
    var Bitmap := Leters[ch];
    System.Console.Clear;
    writeln(f * 10);
    for k: byte := 0 to 11 do
      writeln(f, new string(Bitmap.Col(k).ConvertAll(b -> b = 1 ? f : e)), f);
    writeln(f * 10);
    writeln(ord(ch):3, ' ', ch);
end;

begin
  
  {
  begin
    var b := new Bitmap('A-.bmp');
    for i:word := 1040 to 1103 do
    AddLeter(b, (i-1040)*8, 0, char(i));
  end;
  SaveLaters;
  {}
  
  if true then
  while true do
    ShowChar(ReadlnChar) else
  foreach var ch in Leters.Keys do
  begin
    ShowChar(ch);
    readln;
  end;
end.